/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */

#ifndef _PARTICLE_H
#define _PARTICLE_H

#define PG_STATUS_ALIVE 0
#define PG_STATUS_DEAD  1

#define ROBOT_DATA 0
#define ROOM_DATA 1
#define ROBOT_ROOM_DATA 2


/** 
 \typedef double weight_type
 \brief ď݂^
*/
typedef double weight_type; 

/**
   \struct state_type 
   \brief 1̃p[eBNԂ̃f[^
*/
typedef struct{ 
  double x; 	///<ʒu(x)
  double y;	///<ʒu(y)
  double z;	///<ʒu(z) add by morio 3Dg
  double v;	///<ړx
  double theta;	///<{bg猩p[eBN̊px(0)
  double phi;	///<{bg猩p[eBN̊px(0) add by morio 3Dg
  double orient; ///<}CN猩p[eBN̐is

} state_type;

/**
   \struct history_data 
   \brief f[^(o)
*/
typedef struct{ 
  int Frame_ID;		///<
  double x;		///<ʒu(x)
  double y;		///<ʒu(y)
  double z;		///<ʒu(z)
  double v;		///<x
  double theta;		///<p[eBN̊px
  double phi;		///<p[eBN̊px add by Morio
} history_data;

/**
   \struct particle_group
   \brief P̃p[eBNO[v̏Ԃ̏
*/
typedef struct{ 
  int pg_status;		///<  0:ALIVE(), 1:DEAD()
  state_type *state;		///<
  weight_type *weight;		///< d(ԐƓ),eO[vƂɍvPɂȂ悤ȐKB
   history_data *h;		///< f[^
  int histnum;			///< 
  int histmax;			///< f[^̗̈mۍς݌
  int target;			///< ΉÂĂϑl̔ԍ
  int r_target;			///< ΉÂĂϑl̔ԍ(rob)
  int update_FrameID ;  	///< ŌɊϑꂽt[ԍ   
  int index;			///< p[eBNO[vԍ(unique)        
    //TFIndex 2016.9.26
  int tfindex[3];		///< TFIndex  
} particle_group;

/**
   \struct particle_group_set
   \brief p[eBNO[v̂鎞ł̏Ԃ\
*/
typedef struct{ 
  particle_group *pg;		///<p[eBNO[v^
  int pg_num;			///< p[eBNO[v̌Bɑ
  int pg_alive_num;		///< _ŐĂO[v̐ 
} particle_group_set;


/**
   \struct observation_type
   \brief ϑl(IRMA)̃f[^iPj
*/
typedef struct{ 
  	double x;		///<ʒu
  	double y;		///<ʒu
	double z;		///<ʒu add by Morio 3Dg
	//double theta;	//gpȂ@@///<̐is(gp)
} observation_type;


/**
   \struct observation_set
   \brief 鎞_ł̊ϑl̏W(IRMA)
*/
typedef struct{ 
	observation_type *ob;		///<ϑlf[^(IRMA)
  int ob_num;				///<ϑl()̐
  int ob_FrameID;			///< t[ԍ
} observation_set;

/*
typedef struct{ 
  double pow[27][15];
  double time; 
} rmap_ob;

typedef struct{ 
  double pow[72];
  double time; 
} bmap_ob;
/*

/**
   \brief ϑl(REMA)̃f[^(P)
*/
typedef struct{
  double x;			///<{bg̈ʒu(xW) 
  double y;			///<{bg̈ʒu(yW)
  double z;			///<{bg̈ʒu(yW)
  
  double r_theta;		///<{bg̓ (2008/10/03ǉ)
  double r_phi;			///<{bg̓ (2016/9/21ǉ)
  double theta;			///<ʌʂ̕(deg)
  double phi;			///<ʌʂ̕(deg)
  double likelihood;		//̃p[ɂ茈܂邱̒ʌʂɑ΂ޓx
   
  //TFIndex 2016.9.26
  int tfindex[3];		///< TFIndex  
} robot_observation_type;

/**
   \struct robot_observation_set
   \brief 鎞_ł̊ϑl̏W(REMA)
*/
typedef struct{ 
  robot_observation_type *r_ob;			///<ϑlf[^(REMA)
  int ob_num;					///<ϑl()̐
  int ob_FrameID;				///<t[ԍ
} robot_observation_set;

/**
   \struct PARAM
   \brief FlowDesigner̃p[^܂Ƃ߂\
*/
typedef struct{
	int m_param_particle_num;			///<p[eBN
	int m_param_max_num_of_source;			///<̍ől
	double m_param_th_another_source;		///<Ήt臒l
	double m_param_th_ignore_source;		///<VEł̔f̂߂臒l
	int m_param_th_remove_source;			///<p[eBNO[v폜܂ł̃t[
	double m_param_th_output_range;			///<ςthȓ̋i܂͊pxjɂp[eBNgp
	double m_param_likelihood_sigma;		///<ϑl̖ޓxvZƂ̕U(room)
	double m_param_likelihood_sigma_robot;		///<ϑl̖ޓxvZƂ̕U(room)
	double m_param_likelihood_robot_weight;		///<robɑ΂ď݂vZ
	double m_param_th_random_walk;			///<RandomWalkJڂ̂߂臒l
	double m_param_state_update_sigma;		///<Ԃ̑JڂɉmCY̕U
	double m_param_sum_weight;			///<ߖT̕ρ@or Ŝ̕ρ@臒l
	double m_param_rob_pow;				///<̓f[^Ɣf邩ǂ臒l(room)@(gp)
	double m_param_room_length;			///<̃TCY[m]igpj
	double m_param_room_width;			///<̃TCY[m]igpj
	double m_param_room_pow;			///<̓f[^Ɣf邩ǂ臒l(rob)@igpj
	int m_param_history;
} PARAM;


//20081014ǉ
#ifdef __cplusplus
extern "C" {
#endif

/** 
 * \brief VArŉƂւ̑Ή, \dvp[eBNtB^̘gg݂ɂ͓ĂȂDL
 * \param flag ̓f[^̎ނɂtO(IRMA or REMA or IRMA+REMA)
 * \param Pnum p[eBN
 * \param pg_set p[eBNO[vW
 * \param ob_set ϑlW
 * \param r_set {bgϑlW
 * \param s_param p[^ݒ
 */
void check_source(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, const PARAM s_param);

//void check_source_rmap(int Pnum, particle_group_set *pg_set, rmap_ob *new_rmap); 



// * \fn void group_generate(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, int *used, int rest, const PARAM s_param);

/** 
 * \brief O[v𑝂₷ꍇ̏
 * \param flag ̓f[^̎ނɂtO(IRMA or REMA or IRMA+REMA)
 * \param Pnum p[eBN
 * \param pg_set p[eBNO[vW
 * \param ob_set ϑlW
 * \param r_set {bgϑlW
 * \param used ϑlΉtXg
 * \param rest Ήϑl
 * \param s_param p[^ݒ
 */
void group_generate(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, int *used, int rest, const PARAM s_param);

//void group_generate_rmap(int Pnum, particle_group_set *pg_set, rmap_ob *rmap, int rmap_used[27][15]);
// * \fn void group_delete(int Pnum, particle_group_set *pg_set,  const int *group_used, int ob_FrameID, const PARAM s_param);

/** 
 * \brief O[v炷ꍇ̏: ǐՂĂ闱qO[vc  t[ȏȂO[v폜
 * \param Pnum p[eBN
 * \param pg_set p[eBNO[vW
 * \param group_used ϑlΉtXg
 * \param ob_FrameID t[ԍ
 * \param s_param p[^ݒ
 */
void group_delete(int Pnum, particle_group_set *pg_set,  const int *group_used, int ob_FrameID, const PARAM s_param);


	// * \fn double state_norm(state_type s1, state_type s2);

/**
 * \brief qԂ̋Zo
 * \param s1 1(p[eBNO[v̈ʒu)
 * \param s2 2(P̃p[eBN̈ʒu)
 * \return qԂ̊px̍
*/
double state_norm(state_type s1, state_type s2);

	// * \fn double state_norm(state_type s1, state_type s2);

/**
 * \brief qԂ̊px̍Zo
 * \param s1 1(p[eBNO[v̊px)
 * \param s2 2(P̃p[eBN̊px)
 * \return qԂ̊px̍
 */
double state_norm_rob(state_type s1, state_type s2);

	 //* \fn void state_output(const int flag, int Pnum, const particle_group_set *pg_set, int Frame_ID, const PARAM s_param);

/** 
 * \brief p[eBN̏()̏o
 * \param flag ̓f[^̎ނɂtO(IRMA or REMA or IRMA+REMA)
 * \param Pnum p[eBN
 * \param pg_set p[eBNO[vW
 * \param Frame_ID t[ԍ
 * \param s_param p[^\
*/
void state_output(const int flag, int Pnum, const particle_group_set *pg_set, int Frame_ID, const PARAM s_param);
//void state_output_rmap(FILE *output, int Pnum,  const particle_group_set *pg_set, double time);


	// * \fn int is_in_sink(double x, double y)

///** 
// * \brief Q邩m߂
// * \param x XW
// * \param y YXW
// */
//int is_in_sink(double x, double y);


	// * \fn state_type state_update(const int flag, state_type old_state, int time_diff, const PARAM s_param)

/** 
 * \brief ԂJڂ 
 * \param flag ̓f[^̎ނɂtO(IRMA or REMA or IRMA+REMA)
 * \param old_state  ݂̓
 * \param time_diff  OXV̎
 * \param s_param p[^\
 * \return XVꂽ
 */
state_type state_update(const int flag, state_type old_state, int time_diff, const PARAM s_param);
//state_type state_update_rmap(state_type old_state, double time_diff);


	// * \fn double likelihood(const state_type *state, const observation_type *ob,  const robot_observation_type *r_ob, const PARAM s_param);

/** 
 * \brief stateɑ΂ob̖ޓxvZ \dv
 * \param state 
 * \param ob ϑl
 * \param r_ob {bgϑl
 * \param s_param p[^\
 * \return stateɑ΂ob̖ޓx
*/
double likelihood(const state_type *state, const observation_type *ob,  const robot_observation_type *r_ob, const PARAM s_param);

//double likelihood_rmap(const state_type *state, rmap_ob *rmap,  double x, double y);


	// * \fn weight_type weight_update(const state_type *state, const observation_type *ob, weight_type old_weight, const robot_observation_type *r_ob, const PARAM s_param)

/**
 * \brief d݂̍XV
 * \param state XV̏
 * \param ob Ήtꂽϑl
 * \param old_weight ݂̏d
 * \param r_ob Ήtꂽ{bgϑl
 * \param s_param p[^\
 * \return XVd
 */
weight_type weight_update(const state_type *state, const observation_type *ob, weight_type old_weight, const robot_observation_type *r_ob, const PARAM s_param);
//weight_type weight_update_no_target(const state_type *state, const double h_theta,  const observation_type *ob, weight_type old_weight,  const robot_observation_type *r_ob, const PARAM s_param);
//weight_type weight_update_rmap( const state_type *state, rmap_ob *rmap, weight_type old_weight ); 


// * \fn double randn(double mu, double sigma)

/** 
 *  \brief KEXmCY𔭐
 *  \param mu 
 *  \param sigma U
 *  \return _Ȓl(0`1)
 */
double randn(double mu, double sigma);


	// * \fn void importance_sampling(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, const PARAM s_param)

/** 
 * \brief Ԃ̍XVƏdvx̍XV
 * \param flag ̓f[^̎ނɂtO(IRMA or REMA or IRMA+REMA)
 * \param Pnum q̑
 * \param pg_set qO[vW
 * \param ob_set ϑlW
 * \param r_set  {bgϑlW
 * \param s_param p[^\
 */
void importance_sampling(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, const PARAM s_param);
//void importance_sampling_rmap(int Pnum, particle_group_set *pg_set, rmap_ob *new_rmap); 


	// * \fn void selection(int Pnum, particle_group_set *pg_set)

/** 
 * \brief p[eBN̑(O[v)
 * \param Pnum  Sp[eBN
 * \param pg_set  p[eBNO[vW
 * \param s_param p[^\
 */
void selection(int Pnum, particle_group_set *pg_set, const PARAM s_param);


	// * \fn void SIR(int old_Pnum, int new_Pnum, const state_type *state, const weight_type *weight, state_type *new_state, weight_type *new_weight, const PARAM s_param)

/** 
 * \brief Sampling Importance Resampling
 * \param old_Pnum  O[vp[eBN
 * \param new_Pnum 
 * \param state 
 * \param weight 
 * \param new_state 
 * \param new_weight 
 * \param s_param p[^\
 */
void SIR(int old_Pnum, int new_Pnum, const state_type *state, const weight_type *weight, state_type *new_state, weight_type *new_weight, const PARAM s_param);


/** 
 * \brief count=0Ȃgroup_num0ɏ
 */
void init_group_num(void); //count=0Ȃgroup_num0ɏ

void print_observation_set(observation_set *os);

void print_robot_observation_set(robot_observation_set *os);

void print_state(int Pnum, particle_group_set *pg_set, double time);

#ifdef __cplusplus
}
#endif

#if 0
int get_data(FILE *input, FILE *robot_input, 
	     observation_set *ob_set, robot_observation_set *r_set);
#endif

#endif
